<?php

defined ('_JEXEC') or die('Restricted access');

/**
 * Plugin providing checksums for the VM Ordernumber plugin
 *
 * @copyright Copyright (C) 2016 Reinhold Kainhofer, office@open-tools.net
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 *
 * http://open-tools.net/
 *
 */
if (!class_exists('vmShopperPlugin')) 
    require(JPATH_VM_PLUGINS . DS . 'vmshopperplugin.php');

/** Extension plugin for the Ordernumber plugin for VirtueMart
 */
class plgVmShopperOrdernumber_checksum extends VmShopperPlugin {
    // Unfortunately, this dummy function needs to be implementd, because it's abstract in the parent class!
    public function plgVmOnUpdateOrderBEShopper($_orderID) {}

	/**  Trigger to postprocess generated numbers (e.g. to add checksums or call 
	  *  external bookkeeping systems to store an invoice number).
	  *  The number can be changed by simply assigning a new value to $number.
	  *
	  *  Possible values for $type are "ordernumber", "invoice_number", "customer_number", etc.
	  */
	function onVmOrdernumberPostprocessNumber(&$number, $type, $order) {
		// Example: Append the length of the number to the number
error_log("Called onVmOrdernumberPostprocessNumber with number $number and type $type");
		if ($type=="order_number") {
			$checksum = strlen($number);
			$number .= $checksum;
		}
	}

}

// No closing tag
